import processing.core.*;
import fullscreen.*;  //um im Vollbildmodus starten zu können.

public class GUI extends PApplet
{
    //RungeKuttaIntegrator ruku = new RungeKuttaIntegrator(new SchwingerModell());
    RungeKuttaIntegrator ruku;
    AutonomesVehikel modell;

    boolean AKTIV = false;
    double x,y,phi,vx,vy,omega,t,dt; //Aktueller Zustand des Fahrzeugs, Meter Meter rad
    
    //Position in Pixeln für die Animation:
    int ix,iy;
    
    double[] yalt,yneu;
    public void setup()
    {        
        Par.initialisieren(displayWidth,displayHeight);
        
        modell = new AutonomesVehikel();
        ruku = new RungeKuttaIntegrator(modell);
         
        yalt = new double[modell.holeAnzahlGleichungen()];
        yneu = new double[modell.holeAnzahlGleichungen()];
        initialisieren();
        
        size(displayWidth,displayHeight);
        frameRate(10);
        (new FullScreen(this)).enter();                 
    }

    
    public void zeigeFahrzeug(double x, double y, double phi)
    {
        stroke(255,0,0);
        noFill();
        //Fahrzeugumriß einzeichnen:
        Par.setXYPHI(x,y,phi);
        
        //Bestimmung der Eckpunkte des umschreibenden Rechtecks
        //in Bildschirmkoordinaten:
        float x1 = Par.ktransX(0.5*Par.d,Par.q);        
        float y1 = Par.ktransY(0.5*Par.d,Par.q);        
        
        float x2 = Par.ktransX(-0.5*Par.d,Par.q);        
        float y2 = Par.ktransY(-0.5*Par.d,Par.q);        
        
        float x3 = Par.ktransX(-0.5*Par.d,-Par.q);        
        float y3 = Par.ktransY(-0.5*Par.d,-Par.q);        
        
        float x4 = Par.ktransX(0.5*Par.d,-Par.q);        
        float y4 = Par.ktransY(0.5*Par.d,-Par.q);        
        
        line(x1,y1,x2,y2);
        line(x2,y2,x3,y3);
        line(x3,y3,x4,y4);
        line(x4,y4,x1,y1);
    }
    
    public void draw()
    {
        clear();
        background(200,200,200);
        
        x=yalt[0];
        y=yalt[1];
        phi=yalt[2];
        vx=yalt[3];
        vy=yalt[4];
        omega=yalt[5];        

        //-----------ANIMATION---------------------
        //Fahrzeugumriß einzeichnen:
        zeigeFahrzeug(x,y,phi);
        
        //-----------------------------------------

        if(AKTIV)
        {
            for(int i=0;i<10;i++) //zehnfache Menge an Simulationsschritten ausführen, sonst zu grob.
            {
                for(int k=0;k<yalt.length;k++)
                    yalt[k]=yneu[k];
                yneu = ruku.berechneZeitschritt(yalt,t,dt);    
                t+=dt;
            }
        }
    }

    public void initialisieren()
    {
            x=0.0;
            y=0.0;
            phi=0.0;
            vx=0.0;
            vy=0.0;                        
            omega=0.0;
            t=0.0;
            dt=0.01;
        
            yalt[0]=x;
            yalt[1]=y;
            yalt[2]=phi;
            yalt[3]=vx;
            yalt[4]=vy;
            yalt[5]=omega;
            
            for(int i=0;i<yalt.length;i++)
                yneu[i]=yalt[i];
    }
    
    public void mouseClicked()
    {
        AKTIV=!AKTIV;
        
        if(AKTIV==true)
            initialisieren();
    }

    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "GUI" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }
    
}
